Index: kernel/tgb.cc
===================================================================
--- kernel/tgb.cc	(revision a41623dd1e56318466dc81751481d37d19489c7b)
+++ kernel/tgb.cc	(revision 410ea0fb1e22ebcb52e33b6789cf294a2d1f663b)
@@ -2068,142 +2291,158 @@
 #ifdef NORO_CACHE
 #ifndef NORO_NON_POLY
-void NoroCache::evaluateRows()
+void
+NoroCache::evaluateRows ()
 {
   //after that can evaluate placeholders
   int i;
-  buffer=(number*) omalloc(nIrreducibleMonomials*sizeof(number));
-  for(i=0;i<root.branches_len;i++)
-  {
-    evaluateRows(1,root.branches[i]);
-  }
-  omfree(buffer);
-  buffer=NULL;
-}
-void NoroCache::evaluateRows(int level, NoroCacheNode* node)
-{
-  assume(level>=0);
-  if (node==NULL) return;
-  if (level<pVariables)
-  {
-    int i,sum;
-    for(i=0;i<node->branches_len;i++)
-    {
-      evaluateRows(level+1,node->branches[i]);
+  buffer = (number *) omalloc (nIrreducibleMonomials * sizeof (number));
+  for (i = 0; i < root.branches_len; i++)
+  {
+    evaluateRows (1, root.branches[i]);
+  }
+  omfree (buffer);
+  buffer = NULL;
+}
+
+void
+NoroCache::evaluateRows (int level, NoroCacheNode * node)
+{
+  assume (level >= 0);
+  if (node == NULL)
+    return;
+  if (level < pVariables)
+  {
+    int i, sum;
+    for (i = 0; i < node->branches_len; i++)
+    {
+      evaluateRows (level + 1, node->branches[i]);
     }
   }
   else
   {
-    DataNoroCacheNode* dn=(DataNoroCacheNode*) node;
-    if (dn->value_len!=backLinkCode)
-    {
-      poly p=dn->value_poly;
-      #ifndef NORO_SPARSE_ROWS_PRE
-      dn->row=new DenseRow();
-      DenseRow* row=dn->row;
-      memset(buffer,0,sizeof(number)*nIrreducibleMonomials);
-
-      if (p==NULL) {row->array=NULL;row->begin=0;row->end=0; return;}
-      int i=0;
+    DataNoroCacheNode *dn = (DataNoroCacheNode *) node;
+    if (dn->value_len != backLinkCode)
+    {
+      poly p = dn->value_poly;
+#ifndef NORO_SPARSE_ROWS_PRE
+      dn->row = new DenseRow ();
+      DenseRow *row = dn->row;
+      memset (buffer, 0, sizeof (number) * nIrreducibleMonomials);
+
+      if (p == NULL)
+      {
+	row->array = NULL;
+	row->begin = 0;
+	row->end = 0;
+	return;
+      }
+      int i = 0;
       int idx;
-      number* a=buffer;
-      while(p)
-      {
-        DataNoroCacheNode* ref=getCacheReference(p);
-
-        idx=ref->term_index;
-        assume(idx>=0);
-        a[idx]=p_GetCoeff(p,currRing);
-        if (i==0) row->begin=idx;
-        i++;
-        pIter(p);
-      }
-      row->end=idx+1;
-      assume(row->end>row->begin);
-      int len=row->end-row->begin;
-      row->array=(number*) omalloc((len)*sizeof(number));
-      memcpy(row->array,a+row->begin,len*sizeof(number));
-      #else
-      assume(dn->value_len==pLength(dn->value_poly));
-      dn->row=new SparseRow(dn->value_len);
-      SparseRow* row=dn->row;
-      int i=0;
-      while(p)
-      {
-        DataNoroCacheNode* ref=getCacheReference(p);
-
-        int idx=ref->term_index;
-        assume(idx>=0);
-        row->idx_array[i]=idx;
-        row->coef_array[i]=p_GetCoeff(p,currRing);
-        i++;
-        pIter(p);
-      }
-      if (i!=dn->value_len)
-      {
-        PrintS("F4 calc wrong, as poly len was wrong\n");
-      }
-      assume(i==dn->value_len);
-      #endif
-    }
-  }
-}
-
-void NoroCache::evaluatePlaceHolder(number* row,std::vector<NoroPlaceHolder>& place_holders)
+      number *a = buffer;
+      while (p)
+      {
+	DataNoroCacheNode *ref = getCacheReference (p);
+
+	idx = ref->term_index;
+	assume (idx >= 0);
+	a[idx] = p_GetCoeff (p, currRing);
+	if (i == 0)
+	  row->begin = idx;
+	i++;
+	pIter (p);
+      }
+      row->end = idx + 1;
+      assume (row->end > row->begin);
+      int len = row->end - row->begin;
+      row->array = (number *) omalloc ((len) * sizeof (number));
+      memcpy (row->array, a + row->begin, len * sizeof (number));
+#else
+      assume (dn->value_len == pLength (dn->value_poly));
+      dn->row = new SparseRow (dn->value_len);
+      SparseRow *row = dn->row;
+      int i = 0;
+      while (p)
+      {
+	DataNoroCacheNode *ref = getCacheReference (p);
+
+	int idx = ref->term_index;
+	assume (idx >= 0);
+	row->idx_array[i] = idx;
+	row->coef_array[i] = p_GetCoeff (p, currRing);
+	i++;
+	pIter (p);
+      }
+      if (i != dn->value_len)
+      {
+	PrintS ("F4 calc wrong, as poly len was wrong\n");
+      }
+      assume (i == dn->value_len);
+#endif
+    }
+  }
+}
+
+void
+NoroCache::evaluatePlaceHolder (number * row,
+				std::vector < NoroPlaceHolder >
+				&place_holders)
 {
   int i;
-  int s=place_holders.size();
-  for(i=0;i<s;i++)
-  {
-    DataNoroCacheNode* ref=place_holders[i].ref;
-    number coef=place_holders[i].coef;
-    if (ref->value_len==backLinkCode)
-    {
-      row[ref->term_index]=npAddM(row[ref->term_index],coef);
+  int s = place_holders.size ();
+  for (i = 0; i < s; i++)
+  {
+    DataNoroCacheNode *ref = place_holders[i].ref;
+    number coef = place_holders[i].coef;
+    if (ref->value_len == backLinkCode)
+    {
+      row[ref->term_index] = npAddM (row[ref->term_index], coef);
     }
     else
     {
-      #ifndef NORO_SPARSE_ROWS_PRE
-      DenseRow* ref_row=ref->row;
-      if (ref_row==NULL) continue;
-      number* ref_begin=ref_row->array;
-      number* ref_end=ref_row->array+(ref_row->end-ref_row->begin);
-      number* my_pos=row+ref_row->begin;
+#ifndef NORO_SPARSE_ROWS_PRE
+      DenseRow *ref_row = ref->row;
+      if (ref_row == NULL)
+	continue;
+      number *ref_begin = ref_row->array;
+      number *ref_end = ref_row->array + (ref_row->end - ref_row->begin);
+      number *my_pos = row + ref_row->begin;
       //TODO npisOne distinction
-      if (!(npIsOne(coef)))
-      {
-        while(ref_begin!=ref_end)
-        {
-
-          *my_pos=npAddM(*my_pos,npMult(coef,*ref_begin));
-          ++ref_begin;
-          ++my_pos;
-        }
+      if (!(npIsOne (coef)))
+      {
+	while (ref_begin != ref_end)
+	{
+
+	  *my_pos = npAddM (*my_pos, npMult (coef, *ref_begin));
+	  ++ref_begin;
+	  ++my_pos;
+	}
       }
       else
       {
-        while(ref_begin!=ref_end)
-        {
-
-          *my_pos=npAddM(*my_pos,*ref_begin);
-          ++ref_begin;
-          ++my_pos;
-        }
-      }
-
-    #else
-    SparseRow* ref_row=ref->row;
-    if (ref_row==NULL) continue;
-    int n=ref_row->len;
-    int j;
-    int* idx_array=ref_row->idx_array;
-    number* coef_array=ref_row->coef_array;
-    for(j=0;j<n;j++)
-    {
-      int idx=idx_array[j];
-      number ref_coef=coef_array[j];
-      row[idx]=npAddM(row[idx],npMult(coef,ref_coef));
-    }
-    #endif
-  }
+	while (ref_begin != ref_end)
+	{
+
+	  *my_pos = npAddM (*my_pos, *ref_begin);
+	  ++ref_begin;
+	  ++my_pos;
+	}
+      }
+
+#else
+      SparseRow *ref_row = ref->row;
+      if (ref_row == NULL)
+	continue;
+      int n = ref_row->len;
+      int j;
+      int *idx_array = ref_row->idx_array;
+      number *coef_array = ref_row->coef_array;
+      for (j = 0; j < n; j++)
+      {
+	int idx = idx_array[j];
+	number ref_coef = coef_array[j];
+	row[idx] = npAddM (row[idx], npMult (coef, ref_coef));
+      }
+#endif
+    }
   }
 }
@@ -2213,26 +2452,27 @@
 
 #ifndef NORO_NON_POLY
-MonRedRes noro_red_mon(poly t, BOOLEAN force_unique, NoroCache* cache,slimgb_alg* c)
+MonRedRes
+noro_red_mon (poly t, BOOLEAN force_unique, NoroCache * cache, slimgb_alg * c)
 {
   MonRedRes res_holder;
 
   //wrp(t);
-  res_holder.changed=TRUE;
+  res_holder.changed = TRUE;
   if (force_unique)
   {
-    DataNoroCacheNode* ref=cache->getCacheReference(t);
-    if (ref!=NULL)
-    {
-      res_holder.len=ref->value_len;
-      if (res_holder.len==NoroCache::backLinkCode)
-      {
-        res_holder.len=1;
-      }
-      res_holder.coef=p_GetCoeff(t,c->r);
-      res_holder.p=ref->value_poly;
-      res_holder.ref=ref;
-      res_holder.onlyBorrowed=TRUE;
-      res_holder.changed=TRUE;
-      p_Delete(&t,c->r);
+    DataNoroCacheNode *ref = cache->getCacheReference (t);
+    if (ref != NULL)
+    {
+      res_holder.len = ref->value_len;
+      if (res_holder.len == NoroCache::backLinkCode)
+      {
+	res_holder.len = 1;
+      }
+      res_holder.coef = p_GetCoeff (t, c->r);
+      res_holder.p = ref->value_poly;
+      res_holder.ref = ref;
+      res_holder.onlyBorrowed = TRUE;
+      res_holder.changed = TRUE;
+      p_Delete (&t, c->r);
       return res_holder;
     }
@@ -2241,26 +2481,26 @@
   {
     BOOLEAN succ;
-    poly cache_lookup=cache->lookup(t,succ, res_holder.len);//don't own this yet
+    poly cache_lookup = cache->lookup (t, succ, res_holder.len);	//don't own this yet
     if (succ)
     {
-      if (cache_lookup==t)
-      {
-      //know they are equal
-      //res_holder.len=1;
-
-        res_holder.changed=FALSE;
-        res_holder.p=t;
-        res_holder.coef=npInit(1);
-
-        res_holder.onlyBorrowed=FALSE;
-        return res_holder;
-      }
-
-      res_holder.coef=p_GetCoeff(t,c->r);
-      p_Delete(&t,c->r);
-
-      res_holder.p=cache_lookup;
-
-      res_holder.onlyBorrowed=TRUE;
+      if (cache_lookup == t)
+      {
+	//know they are equal
+	//res_holder.len=1;
+
+	res_holder.changed = FALSE;
+	res_holder.p = t;
+	res_holder.coef = npInit (1);
+
+	res_holder.onlyBorrowed = FALSE;
+	return res_holder;
+      }
+
+      res_holder.coef = p_GetCoeff (t, c->r);
+      p_Delete (&t, c->r);
+
+      res_holder.p = cache_lookup;
+
+      res_holder.onlyBorrowed = TRUE;
       return res_holder;
 
@@ -2268,66 +2508,66 @@
   }
 
-  unsigned long sev=p_GetShortExpVector(t,currRing);
-  int i=kFindDivisibleByInS_easy(c->strat,t,sev);
-  if (i>=0)
-  {
-    number coef_bak=p_GetCoeff(t,c->r);
-
-    p_SetCoeff(t,npInit(1),c->r);
-    assume(npIsOne(p_GetCoeff(c->strat->S[i],c->r)));
-    number coefstrat=p_GetCoeff(c->strat->S[i],c->r);
-
-      //poly t_copy_mon=p_Copy(t,c->r);
-    poly exp_diff=cache->temp_term;
-    p_ExpVectorDiff(exp_diff,t,c->strat->S[i],c->r);
-    p_SetCoeff(exp_diff,npNeg(nInvers(coefstrat)),c->r);
-      // nInvers may be npInvers or nvInvers
-    p_Setm(exp_diff,c->r);
-    assume(c->strat->S[i]!=NULL);
-      //poly t_to_del=t;
+  unsigned long sev = p_GetShortExpVector (t, currRing);
+  int i = kFindDivisibleByInS_easy (c->strat, t, sev);
+  if (i >= 0)
+  {
+    number coef_bak = p_GetCoeff (t, c->r);
+
+    p_SetCoeff (t, npInit (1), c->r);
+    assume (npIsOne (p_GetCoeff (c->strat->S[i], c->r)));
+    number coefstrat = p_GetCoeff (c->strat->S[i], c->r);
+
+    //poly t_copy_mon=p_Copy(t,c->r);
+    poly exp_diff = cache->temp_term;
+    p_ExpVectorDiff (exp_diff, t, c->strat->S[i], c->r);
+    p_SetCoeff (exp_diff, npNeg (nInvers (coefstrat)), c->r);
+    // nInvers may be npInvers or nvInvers
+    p_Setm (exp_diff, c->r);
+    assume (c->strat->S[i] != NULL);
+    //poly t_to_del=t;
     poly res;
-    res=pp_Mult_mm(pNext(c->strat->S[i]),exp_diff,c->r);
-
-    res_holder.len=c->strat->lenS[i]-1;
-    res=noro_red_non_unique(res,res_holder.len,cache,c);
-
-    DataNoroCacheNode* ref=cache->insert(t,res,res_holder.len);
-    p_Delete(&t,c->r);
-      //p_Delete(&t_copy_mon,c->r);
-      //res=pMult_nn(res,coef_bak);
-    res_holder.changed=TRUE;
-    res_holder.p=res;
-    res_holder.coef=coef_bak;
-    res_holder.onlyBorrowed=TRUE;
-    res_holder.ref=ref;
+    res = pp_Mult_mm (pNext (c->strat->S[i]), exp_diff, c->r);
+
+    res_holder.len = c->strat->lenS[i] - 1;
+    res = noro_red_non_unique (res, res_holder.len, cache, c);
+
+    DataNoroCacheNode *ref = cache->insert (t, res, res_holder.len);
+    p_Delete (&t, c->r);
+    //p_Delete(&t_copy_mon,c->r);
+    //res=pMult_nn(res,coef_bak);
+    res_holder.changed = TRUE;
+    res_holder.p = res;
+    res_holder.coef = coef_bak;
+    res_holder.onlyBorrowed = TRUE;
+    res_holder.ref = ref;
     return res_holder;
   }
   else
   {
-    number coef_bak=p_GetCoeff(t,c->r);
-    number one=npInit(1);
-    p_SetCoeff(t,one,c->r);
-    res_holder.len=1;
+    number coef_bak = p_GetCoeff (t, c->r);
+    number one = npInit (1);
+    p_SetCoeff (t, one, c->r);
+    res_holder.len = 1;
     if (!(force_unique))
     {
-      res_holder.ref=cache->insert(t,t,res_holder.len);
-      p_SetCoeff(t,coef_bak,c->r);
+      res_holder.ref = cache->insert (t, t, res_holder.len);
+      p_SetCoeff (t, coef_bak, c->r);
       //return t;
 
       //we need distinction
-      res_holder.changed=FALSE;
-      res_holder.p=t;
-
-      res_holder.coef=npInit(1);
-      res_holder.onlyBorrowed=FALSE;
+      res_holder.changed = FALSE;
+      res_holder.p = t;
+
+      res_holder.coef = npInit (1);
+      res_holder.onlyBorrowed = FALSE;
       return res_holder;
     }
     else
     {
-      res_holder.ref=cache->insertAndTransferOwnerShip(t,c->r);
-      res_holder.coef=coef_bak;
-      res_holder.onlyBorrowed=TRUE;
-      res_holder.changed=FALSE;
-      res_holder.p=t;
+      res_holder.ref = cache->insertAndTransferOwnerShip (t, c->r);
+      res_holder.coef = coef_bak;
+      res_holder.onlyBorrowed = TRUE;
+      res_holder.changed = FALSE;
+      res_holder.p = t;
       return res_holder;
     }
@@ -2339,70 +2579,72 @@
 #ifndef NORO_NON_POLY
 //len input and out: Idea: reverse addition
-poly noro_red_non_unique(poly p, int &len, NoroCache* cache,slimgb_alg* c)
-{
-  assume(len==pLength(p));
-  poly orig_p=p;
-  if (p==NULL) {
-    len=0;
+poly
+noro_red_non_unique (poly p, int &len, NoroCache * cache, slimgb_alg * c)
+{
+  assume (len == pLength (p));
+  poly orig_p = p;
+  if (p == NULL)
+  {
+    len = 0;
     return NULL;
   }
-  kBucket_pt bucket=kBucketCreate(currRing);
-  kBucketInit(bucket,NULL,0);
-  poly unchanged_head=NULL;
-  poly unchanged_tail=NULL;
-  int unchanged_size=0;
-
-  while(p)
-  {
-    poly t=p;
-    pIter(p);
-    pNext(t)=NULL;
+  kBucket_pt bucket = kBucketCreate (currRing);
+  kBucketInit (bucket, NULL, 0);
+  poly unchanged_head = NULL;
+  poly unchanged_tail = NULL;
+  int unchanged_size = 0;
+
+  while (p)
+  {
+    poly t = p;
+    pIter (p);
+    pNext (t) = NULL;
 #ifndef NDEBUG
-    number coef_debug=p_GetCoeff(t,currRing);
-#endif
-    MonRedRes red=noro_red_mon(t,FALSE,cache,c);
-    if ((!(red.changed))&&(!(red.onlyBorrowed)))
+    number coef_debug = p_GetCoeff (t, currRing);
+#endif
+    MonRedRes red = noro_red_mon (t, FALSE, cache, c);
+    if ((!(red.changed)) && (!(red.onlyBorrowed)))
     {
       unchanged_size++;
-      assume(npIsOne(red.coef));
-      assume(p_GetCoeff(red.p,currRing)==coef_debug);
+      assume (npIsOne (red.coef));
+      assume (p_GetCoeff (red.p, currRing) == coef_debug);
       if (unchanged_head)
       {
-        pNext(unchanged_tail)=red.p;
-        pIter(unchanged_tail);
+	pNext (unchanged_tail) = red.p;
+	pIter (unchanged_tail);
       }
       else
       {
-        unchanged_tail=red.p;
-        unchanged_head=red.p;
+	unchanged_tail = red.p;
+	unchanged_head = red.p;
       }
     }
     else
     {
-      assume(red.len==pLength(red.p));
+      assume (red.len == pLength (red.p));
       if (red.onlyBorrowed)
       {
-        if (npIsOne(red.coef))
-        {
-          t=p_Copy(red.p,currRing);
-        }
-        else
-        t=pp_Mult_nn(red.p,red.coef,currRing);
+	if (npIsOne (red.coef))
+	{
+	  t = p_Copy (red.p, currRing);
+	}
+	else
+	  t = pp_Mult_nn (red.p, red.coef, currRing);
       }
       else
       {
-        if (npIsOne(red.coef))
-        t=red.p;
-        else
-         t=p_Mult_nn(red.p,red.coef,currRing);
-      }
-      kBucket_Add_q(bucket,t,&red.len);
-    }
-  }
-  poly res=NULL;
-  len=0;
-  kBucket_Add_q(bucket,unchanged_head,&unchanged_size);
-  kBucketClear(bucket,&res,&len);
-  kBucketDestroy(&bucket);
+	if (npIsOne (red.coef))
+	  t = red.p;
+	else
+	  t = p_Mult_nn (red.p, red.coef, currRing);
+      }
+      kBucket_Add_q (bucket, t, &red.len);
+    }
+  }
+  poly res = NULL;
+  len = 0;
+  kBucket_Add_q (bucket, unchanged_head, &unchanged_size);
+  kBucketClear (bucket, &res, &len);
+  kBucketDestroy (&bucket);
   return res;
 }
@@ -2432,25 +2674,26 @@
 //len input and out: Idea: reverse addition
 #ifndef NORO_NON_POLY
-std::vector<NoroPlaceHolder> noro_red(poly p, int &len, NoroCache* cache,slimgb_alg* c)
-{
-  std::vector<NoroPlaceHolder> res;
-   while(p)
-   {
-      poly t=p;
-      pIter(p);
-      pNext(t)=NULL;
-
-      MonRedRes red=noro_red_mon(t,TRUE,cache,c);
-      assume(red.onlyBorrowed);
-      assume(red.coef);
-      assume(red.ref);
-      NoroPlaceHolder h;
-      h.ref=red.ref;
-      h.coef=red.coef;
-      assume(!((h.ref->value_poly==NULL) &&(h.ref->value_len!=0)));
-      if (h.ref->value_poly)
-        res.push_back(h);
-    }
-    return res;
+std::vector < NoroPlaceHolder > noro_red (poly p, int &len, NoroCache * cache,
+					  slimgb_alg * c)
+{
+  std::vector < NoroPlaceHolder > res;
+  while (p)
+  {
+    poly t = p;
+    pIter (p);
+    pNext (t) = NULL;
+
+    MonRedRes red = noro_red_mon (t, TRUE, cache, c);
+    assume (red.onlyBorrowed);
+    assume (red.coef);
+    assume (red.ref);
+    NoroPlaceHolder h;
+    h.ref = red.ref;
+    h.coef = red.coef;
+    assume (!((h.ref->value_poly == NULL) && (h.ref->value_len != 0)));
+    if (h.ref->value_poly)
+      res.push_back (h);
+  }
+  return res;
 }
 #endif
@@ -2459,10 +2702,11 @@
 #ifdef USE_NORO
 #ifndef NORO_CACHE
-void noro_step(poly*p,int &pn,slimgb_alg* c)
-{
-  poly* reduced=(poly*) omalloc(pn*sizeof(poly));
+void
+noro_step (poly * p, int &pn, slimgb_alg * c)
+{
+  poly *reduced = (poly *) omalloc (pn * sizeof (poly));
   int j;
-  int* reduced_len=(int*) omalloc(pn*sizeof(int));
-  int reduced_c=0;
+  int *reduced_len = (int *) omalloc (pn * sizeof (int));
+  int reduced_c = 0;
   //if (TEST_OPT_PROT)
   //  PrintS("reduced system:\n");
@@ -2470,66 +2714,66 @@
   NoroCache cache;
 #endif
-  for(j=0;j<pn;j++)
-  {
-
-    poly h=p[j];
-    int h_len=pLength(h);
+  for (j = 0; j < pn; j++)
+  {
+
+    poly h = p[j];
+    int h_len = pLength (h);
 
     number coef;
 #ifndef NORO_CACHE
-    h=redNF2(p_Copy(h,c->r),c,h_len,coef,0);
+    h = redNF2 (p_Copy (h, c->r), c, h_len, coef, 0);
 #else
-    h=noro_red(p_Copy(h,c->r),h_len,&cache,c);
-    assume(pLength(h)==h_len);
-#endif
-    if (h!=NULL)
+    h = noro_red (p_Copy (h, c->r), h_len, &cache, c);
+    assume (pLength (h) == h_len);
+#endif
+    if (h != NULL)
     {
 #ifndef NORO_CACHE
 
-      h=redNFTail(h,c->strat->sl,c->strat,h_len);
-      h_len=pLength(h);
-#endif
-      reduced[reduced_c]=h;
-      reduced_len[reduced_c]=h_len;
+      h = redNFTail (h, c->strat->sl, c->strat, h_len);
+      h_len = pLength (h);
+#endif
+      reduced[reduced_c] = h;
+      reduced_len[reduced_c] = h_len;
       reduced_c++;
       if (TEST_OPT_PROT)
-        Print("%d ",h_len);
-    }
-  }
-  int reduced_sum=0;
-  for(j=0;j<reduced_c;j++)
-  {
-    reduced_sum+=reduced_len[j];
-  }
-  poly* terms=(poly*) omalloc(reduced_sum*sizeof(poly));
-  int tc=0;
-  for(j=0;j<reduced_c;j++)
-  {
-    poly h=reduced[j];
-
-    while(h!=NULL)
-    {
-      terms[tc++]=h;
-      pIter(h);
-      assume(tc<=reduced_sum);
-    }
-  }
-  assume(tc==reduced_sum);
-  qsort(terms,reduced_sum,sizeof(poly),terms_sort_crit);
-  int nterms=reduced_sum;
+	Print ("%d ", h_len);
+    }
+  }
+  int reduced_sum = 0;
+  for (j = 0; j < reduced_c; j++)
+  {
+    reduced_sum += reduced_len[j];
+  }
+  poly *terms = (poly *) omalloc (reduced_sum * sizeof (poly));
+  int tc = 0;
+  for (j = 0; j < reduced_c; j++)
+  {
+    poly h = reduced[j];
+
+    while (h != NULL)
+    {
+      terms[tc++] = h;
+      pIter (h);
+      assume (tc <= reduced_sum);
+    }
+  }
+  assume (tc == reduced_sum);
+  qsort (terms, reduced_sum, sizeof (poly), terms_sort_crit);
+  int nterms = reduced_sum;
   //if (TEST_OPT_PROT)
   //Print("orig estimation:%i\n",reduced_sum);
-  unify_terms(terms,nterms);
+  unify_terms (terms, nterms);
   //if (TEST_OPT_PROT)
   //    Print("actual number of columns:%i\n",nterms);
-  int rank=reduced_c;
-  linalg_step_modp(reduced, p,rank,terms,nterms,c);
-  omfree(terms);
-
-  pn=rank;
-  omfree(reduced);
+  int rank = reduced_c;
+  linalg_step_modp (reduced, p, rank, terms, nterms, c);
+  omfree (terms);
+
+  pn = rank;
+  omfree (reduced);
 
   if (TEST_OPT_PROT)
-    PrintS("\n");
+    PrintS ("\n");
 }
 #else
@@ -2537,107 +2781,113 @@
 #endif
 #endif
-static void go_on (slimgb_alg* c)
+static void
+go_on (slimgb_alg * c)
 {
   //set limit of 1000 for multireductions, at the moment for
   //programming reasons
-  #ifdef USE_NORO
+#ifdef USE_NORO
   //Print("module rank%d\n",c->S->rank);
-    const BOOLEAN use_noro=c->use_noro;
-  #else
-  const BOOLEAN use_noro=FALSE;
-  #endif
-  int i=0;
-  c->average_length=0;
-  for(i=0;i<c->n;i++)
-  {
-    c->average_length+=c->lengths[i];
-  }
-  c->average_length=c->average_length/c->n;
-  i=0;
-  int max_pairs=bundle_size;
-
-  #ifdef USE_NORO
-  if ((use_noro)||(c->use_noro_last_block))
-    max_pairs=bundle_size_noro;
-  #endif
-  poly* p=(poly*) omalloc((max_pairs+1)*sizeof(poly));//nullterminated
-
-  int curr_deg=-1;
-  while(i<max_pairs)
-  {
-    sorted_pair_node* s=top_pair(c);//here is actually chain criterium done
-
-    if (!s) break;
-
-    if(curr_deg>=0)
-    {
-      if (s->deg >curr_deg) break;
-    }
-
-    else curr_deg=s->deg;
-    quick_pop_pair(c);
-    if(s->i>=0)
+  const BOOLEAN use_noro = c->use_noro;
+#else
+  const BOOLEAN use_noro = FALSE;
+#endif
+  int i = 0;
+  c->average_length = 0;
+  for (i = 0; i < c->n; i++)
+  {
+    c->average_length += c->lengths[i];
+  }
+  c->average_length = c->average_length / c->n;
+  i = 0;
+  int max_pairs = bundle_size;
+
+#ifdef USE_NORO
+  if ((use_noro) || (c->use_noro_last_block))
+    max_pairs = bundle_size_noro;
+#endif
+  poly *p = (poly *) omalloc ((max_pairs + 1) * sizeof (poly));	//nullterminated
+
+  int curr_deg = -1;
+  while (i < max_pairs)
+  {
+    sorted_pair_node *s = top_pair (c);	//here is actually chain criterium done
+
+    if (!s)
+      break;
+
+    if (curr_deg >= 0)
+    {
+      if (s->deg > curr_deg)
+	break;
+    }
+
+    else
+      curr_deg = s->deg;
+    quick_pop_pair (c);
+    if (s->i >= 0)
     {
       //be careful replace_pair use createShortSpoly which is not noncommutative
-      now_t_rep(s->i,s->j,c);
-    replace_pair(s->i,s->j,c);
-
-    if(s->i==s->j) {
-      free_sorted_pair_node(s,c->r);
-      continue;
-    }
-    now_t_rep(s->i,s->j,c);
+      now_t_rep (s->i, s->j, c);
+      replace_pair (s->i, s->j, c);
+
+      if (s->i == s->j)
+      {
+	free_sorted_pair_node (s, c->r);
+	continue;
+      }
+      now_t_rep (s->i, s->j, c);
     }
     poly h;
-    if(s->i>=0)
+    if (s->i >= 0)
     {
 #ifdef HAVE_PLURAL
       if (c->nc)
       {
-        h= nc_CreateSpoly(c->S->m[s->i], c->S->m[s->j]/*, NULL*/, c->r);
-
-        if (h!=NULL)
-          p_Cleardenom(h, c->r);
+	h = nc_CreateSpoly (c->S->m[s->i], c->S->m[s->j] /*, NULL */ , c->r);
+
+	if (h != NULL)
+	  p_Cleardenom (h, c->r);
       }
       else
 #endif
-        h=ksOldCreateSpoly(c->S->m[s->i], c->S->m[s->j], NULL, c->r);
-    p_Test(h,c->r);
+	h = ksOldCreateSpoly (c->S->m[s->i], c->S->m[s->j], NULL, c->r);
+      p_Test (h, c->r);
     }
     else
     {
-      h=s->lcm_of_lm;
-      p_Test(h,c->r);
-  }
+      h = s->lcm_of_lm;
+      p_Test (h, c->r);
+    }
     // if(s->i>=0)
 //       now_t_rep(s->j,s->i,c);
     number coef;
-    int mlen=pLength(h);
-    p_Test(h,c->r);
-    if ((!c->nc)&(!(use_noro)))
-    {
-      h=redNF2(h,c,mlen,coef,2);
-      redTailShort(h,c->strat);
-      nDelete(&coef);
-    }
-    p_Test(h,c->r);
-    free_sorted_pair_node(s,c->r);
-    if(!h) continue;
-    p[i]=h;
+    int mlen = pLength (h);
+    p_Test (h, c->r);
+    if ((!c->nc) & (!(use_noro)))
+    {
+      h = redNF2 (h, c, mlen, coef, 2);
+      redTailShort (h, c->strat);
+      nDelete (&coef);
+    }
+    p_Test (h, c->r);
+    free_sorted_pair_node (s, c->r);
+    if (!h)
+      continue;
+    p[i] = h;
     i++;
   }
-  p[i]=NULL;
+  p[i] = NULL;
 //  pre_comp(p,i,c);
-  if(i==0)
-  {
-    omfree(p);
+  if (i == 0)
+  {
+    omfree (p);
     return;
   }
-  #ifdef TGB_RESORT_PAIRS
-  c->replaced=new bool[c->n];
-  c->used_b=FALSE;
-  #endif
-
-  c->normal_forms+=i;
+#ifdef TGB_RESORT_PAIRS
+  c->replaced = new bool[c->n];
+  c->used_b = FALSE;
+#endif
+
+  c->normal_forms += i;
   int j;
 #ifdef USE_NORO
@@ -2646,21 +2896,25 @@
   if (use_noro)
   {
-    int pn=i;
-    if (pn==0) {omfree(p);return;}
-    {
-      if (npPrimeM<255)
-      {
-        noro_step<tgb_uint8>(p,pn,c);
+    int pn = i;
+    if (pn == 0)
+    {
+      omfree (p);
+      return;
+    }
+    {
+      if (npPrimeM < 255)
+      {
+	noro_step < tgb_uint8 > (p, pn, c);
       }
       else
       {
-        if (npPrimeM<65000)
-        {
-          noro_step<tgb_uint16>(p,pn,c);
-        }
-        else
-        {
-          noro_step<tgb_uint32>(p,pn,c);
-        }
+	if (npPrimeM < 65000)
+	{
+	  noro_step < tgb_uint16 > (p, pn, c);
+	}
+	else
+	{
+	  noro_step < tgb_uint32 > (p, pn, c);
+	}
       }
     }
@@ -2670,113 +2924,120 @@
     //  Print("reported rank:%i\n",pn);
     //}
-    mass_add(p,pn,c);
-    omfree(p);
+    mass_add (p, pn, c);
+    omfree (p);
     return;
     /*if (TEST_OPT_PROT)
-      for(j=0;j<pn;j++)
-      {
-        p_wrp(p[j],c->r);
-      }*/
-  }
-#endif
-  red_object* buf=(red_object*) omalloc(i*sizeof(red_object));
-  for(j=0;j<i;j++)
-  {
-    p_Test(p[j],c->r);
-    buf[j].p=p[j];
-    buf[j].sev=pGetShortExpVector(p[j]);
-    buf[j].bucket = kBucketCreate(currRing);
-    p_Test(p[j],c->r);
+       for(j=0;j<pn;j++)
+       {
+       p_wrp(p[j],c->r);
+       } */
+  }
+#endif
+  red_object *buf = (red_object *) omalloc (i * sizeof (red_object));
+  for (j = 0; j < i; j++)
+  {
+    p_Test (p[j], c->r);
+    buf[j].p = p[j];
+    buf[j].sev = pGetShortExpVector (p[j]);
+    buf[j].bucket = kBucketCreate (currRing);
+    p_Test (p[j], c->r);
     if (c->eliminationProblem)
     {
-        buf[j].sugar=c->pTotaldegree_full(p[j]);
-    }
-    int len=pLength(p[j]);
-    kBucketInit(buf[j].bucket,buf[j].p,len);
-    buf[j].initial_quality=buf[j].guess_quality(c);
-    assume(buf[j].initial_quality>=0);
-  }
-  omfree(p);
-  qsort(buf,i,sizeof(red_object),red_object_better_gen);
+      buf[j].sugar = c->pTotaldegree_full (p[j]);
+    }
+    int len = pLength (p[j]);
+    kBucketInit (buf[j].bucket, buf[j].p, len);
+    buf[j].initial_quality = buf[j].guess_quality (c);
+    assume (buf[j].initial_quality >= 0);
+  }
+  omfree (p);
+  qsort (buf, i, sizeof (red_object), red_object_better_gen);
 //    Print("\ncurr_deg:%i\n",curr_deg);
   if (TEST_OPT_PROT)
   {
-    Print("%dM[%d,",curr_deg,i);
-  }
-
-  multi_reduction(buf, i, c);
-  #ifdef TGB_RESORT_PAIRS
-  if (c->used_b) {
+    Print ("%dM[%d,", curr_deg, i);
+  }
+
+  multi_reduction (buf, i, c);
+#ifdef TGB_RESORT_PAIRS
+  if (c->used_b)
+  {
     if (TEST_OPT_PROT)
-        PrintS("B");
+      PrintS ("B");
     int e;
-    for(e=0;e<=c->pair_top;e++)
-    {
-        if(c->apairs[e]->i<0) continue;
-        assume(c->apairs[e]->j>=0);
-        if ((c->replaced[c->apairs[e]->i])||(c->replaced[c->apairs[e]->j])) {
-            sorted_pair_node* s=c->apairs[e];
-            s->expected_length=pair_weighted_length(s->i,s->j,c);
-        }
-    }
-    qsort(c->apairs,c->pair_top+1,sizeof(sorted_pair_node*),tgb_pair_better_gen2);
-  }
-  #endif
+    for (e = 0; e <= c->pair_top; e++)
+    {
+      if (c->apairs[e]->i < 0)
+	continue;
+      assume (c->apairs[e]->j >= 0);
+      if ((c->replaced[c->apairs[e]->i]) || (c->replaced[c->apairs[e]->j]))
+      {
+	sorted_pair_node *s = c->apairs[e];
+	s->expected_length = pair_weighted_length (s->i, s->j, c);
+      }
+    }
+    qsort (c->apairs, c->pair_top + 1, sizeof (sorted_pair_node *),
+	   tgb_pair_better_gen2);
+  }
+#endif
 #ifdef TGB_DEBUG
- {
-   int k;
-   for(k=0;k<i;k++)
-   {
-     assume(kFindDivisibleByInS_easy(c->strat,buf[k])<0);
-     int k2;
-     for(k2=0;k2<i;k2++)
-     {
-       if(k==k2) continue;
-       assume((!(p_LmDivisibleBy(buf[k].p,buf[k2].p,c->r)))||(wrp(buf[k].p),Print(" k %d k2 %d ",k,k2),wrp(buf[k2].p),FALSE));
-     }
-   }
- }
+  {
+    int k;
+    for (k = 0; k < i; k++)
+    {
+      assume (kFindDivisibleByInS_easy (c->strat, buf[k]) < 0);
+      int k2;
+      for (k2 = 0; k2 < i; k2++)
+      {
+	if (k == k2)
+	  continue;
+	assume ((!(p_LmDivisibleBy (buf[k].p, buf[k2].p, c->r)))
+		|| (wrp (buf[k].p), Print (" k %d k2 %d ", k, k2),
+		    wrp (buf[k2].p), FALSE));
+      }
+    }
+  }
 #endif
   //resort S
 
   if (TEST_OPT_PROT)
-      Print("%i]",i);
-
-  poly* add_those=(poly*) omalloc(i*sizeof(poly));
-  for(j=0;j<i;j++)
+    Print ("%i]", i);
+
+  poly *add_those = (poly *) omalloc (i * sizeof (poly));
+  for (j = 0; j < i; j++)
   {
     int len;
     poly p;
-    buf[j].flatten();
-    kBucketClear(buf[j].bucket,&p, &len);
-    kBucketDestroy(&buf[j].bucket);
-    p_Test(p,c->r);
+    buf[j].flatten ();
+    kBucketClear (buf[j].bucket, &p, &len);
+    kBucketDestroy (&buf[j].bucket);
+    p_Test (p, c->r);
     //if (!c->nc) {
-      if ((c->tailReductions) ||(lies_in_last_dp_block(p,c)))
-      {
-      p=redNFTail(p,c->strat->sl,c->strat, 0);
-      }
-      else
-      {
-      p=redTailShort(p, c->strat);
-      }
-      //}
-      p_Test(p,c->r);
-      add_those[j]=p;
+    if ((c->tailReductions) || (lies_in_last_dp_block (p, c)))
+    {
+      p = redNFTail (p, c->strat->sl, c->strat, 0);
+    }
+    else
+    {
+      p = redTailShort (p, c->strat);
+    }
+    //}
+    p_Test (p, c->r);
+    add_those[j] = p;
 
     //sbuf[j]=add_to_basis(p,-1,-1,c,ibuf+j);
   }
-  mass_add(add_those,i,c);
-  omfree(add_those);
-  omfree(buf);
+  mass_add (add_those, i, c);
+  omfree (add_those);
+  omfree (buf);
 
   if (TEST_OPT_PROT)
-      Print("(%d)",c->pair_top+1);
+    Print ("(%d)", c->pair_top + 1);
   //TODO: implement that while(!(idIs0(c->add_later)))
-  #ifdef TGB_RESORT_PAIRS
+#ifdef TGB_RESORT_PAIRS
   delete c->replaced;
-  c->replaced=NULL;
-  c->used_b=FALSE;
-  #endif
+  c->replaced = NULL;
+  c->used_b = FALSE;
+#endif
   return;
 }
